#!/usr/bin/python2.5

from py2deb import *


__appname__ = "doneit"
__description__ = "Todo Manager"
__author__ = "Ed Page"
__email__ = "eopage@byu.net"
__version__ = "0.3.1"
__build__ = 0
__changelog__ = '''\
0.3.1
 * Fixed bug where if you had no backend enabled, you couldn't enable a backend (Now hit "Connect" in the "File" menu)
 * Fixed some polish bugs with the popup calendar
 * Caching added to RTM backend

0.3.0
 * Initial Release
 * Backend Support: Remember The Milk
 * Completing of tasks
 * Browse to task URLs
 * Task editing:
   * Task list
   * Task Name
   * Task Priority
   * Task Due Date
 * Note Viewer / Editor
 * Not supported:
   * Adding, renaming, and (un)archiving of lists
   * Uncompleting a task and viewing completed tasks
   * Viewing/editing of task recurrence, time estimate, tags, location, url
   * Postponing tasks
   * Due time
'''


__postinstall__ = '''#!/bin/sh

gtk-update-icon-cache /usr/share/icons/hicolor
'''


def find_files(path):
	for root, dirs, files in os.walk(path):
		for file in files:
			if file.startswith("src-"):
				fileParts = file.split("-")
				unused, relPathParts, newName = fileParts[0], fileParts[1:-1], fileParts[-1]
				assert unused == "src"
				relPath = os.sep.join(relPathParts)
				yield relPath, file, newName


def unflatten_files(files):
	d = {}
	for relPath, oldName, newName in files:
		if relPath not in d:
			d[relPath] = []
		d[relPath].append((oldName, newName))
	return d


if __name__ == "__main__":
	try:
		os.chdir(os.path.dirname(sys.argv[0]))
	except:
		pass

	p = Py2deb(__appname__)
	p.description = __description__
	p.author = __author__
	p.mail = __email__
	p.license = "lgpl"
	p.depends = "python2.5, python2.5-gtk2"
	p.section = "user/communication"
	p.arch = "all"
	p.urgency = "low"
	p.distribution = "chinook diablo"
	p.repository = "extras-devel"
	p.changelog = __changelog__
	p.postinstall = __postinstall__
	p.icon="26x26-doneit.png"
	p["/usr/bin"] = [ "doneit.py" ]
	for relPath, files in unflatten_files(find_files(".")).iteritems():
		fullPath = "/usr/lib/doneit"
		if relPath:
			fullPath += os.sep+relPath
		p[fullPath] = list(
			"|".join((oldName, newName))
			for (oldName, newName) in files
		)
	p["/usr/share/applications/hildon"] = ["doneit.desktop"]
	# p["/usr/share/icons/hicolor/26x26/hildon"] = ["26x26-doneit.png|doneit.png"]
	# p["/usr/share/icons/hicolor/64x64/hildon"] = ["64x64-doneit.png|doneit.png"]
	# p["/usr/share/icons/hicolor/scalable/hildon"] = ["scale-doneit.png|doneit.png"]

	print p
	print p.generate(
		__version__, __build__, changelog=__changelog__,
		tar=True, dsc=True, changes=True, build=False, src=True
	)
