import os

import test_backend

import sys
sys.path.append("../src")

import file_backend
import cache_backend


class TestCacheBackend(object):

	def test_projects(self):
		fileBackend = file_backend.FileBackend(os.tmpnam())
		backend = cache_backend.LazyCacheBackend(fileBackend)

		test_backend.exercise_projects(backend)

		test_backend.assert_projects_same(fileBackend, backend)

	def test_locations(self):
		fileBackend = file_backend.FileBackend(os.tmpnam())
		backend = cache_backend.LazyCacheBackend(fileBackend)

		test_backend.exercise_locations(backend)

		test_backend.assert_locations_same(fileBackend, backend)

	def test_task(self):
		fileBackend = file_backend.FileBackend(os.tmpnam())
		backend = cache_backend.LazyCacheBackend(fileBackend)
		proj1Id = backend.add_project("p1")
		proj2Id = backend.add_project("p2")

		test_backend.exercise_task(backend, proj1Id, proj2Id)

		test_backend.assert_tasks_same(fileBackend, backend, proj1Id)
		test_backend.assert_tasks_same(fileBackend, backend, proj2Id)
